﻿@using System.Web.UI.WebControls;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;

@using Portal.Models.Receiving.KanbanReceivingManifestLevel;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.DevExpress().GridView(
setting =>
{
    setting.Name = "GridKanbanReceivingManifestLevel";
    setting.KeyFieldName = "PART_NO";
    setting.CallbackRouteValues = new { Controller = "KanbanReceivingManifestLevel", Action = "PartialData" };
    //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
    //setting.ClientSideEvents.CustomButtonClick = "func";
    //setting.ClientSideEvents.Init = "grid_init";
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Width = Unit.Percentage(100);

    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = false;
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;
    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(20);
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    
    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        //--=== List object
        object[] PART_NO = new object[end - startIndex];
        //object[] AMOUNT = new object[end - startIndex];
        //decimal TOTAL_AMOUNT = 0;

        for (int n = startIndex; n < end; n++)
        {
            PART_NO[n - startIndex] = grid.GetRowValues(n, "PART_NO");
            //AMOUNT[n - startIndex] = grid.GetRowValues(n, "AMOUNT");
            //TOTAL_AMOUNT += (decimal)grid.GetRowValues(n, "AMOUNT");
        }

        e.Properties["cpPART_NO"] = PART_NO;
        //e.Properties["cpAMOUNT"] = AMOUNT;
        //e.Properties["cpTOTAL_AMOUNT"] = TOTAL_AMOUNT;

        //e.Properties["cpVisibleRow"] = grid.VisibleRowCount;
        //e.Properties["cpKeyfield"] = grid.KeyFieldName;

        //grid.JSProperties["cpStart"] = startIndex;
        //grid.JSProperties["cpEnd"] = end;
        //grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;

    };
    
    setting.CommandColumn.SetHeaderTemplateContent(
    c =>
    {
        Html.DevExpress().CheckBox(
                chckBox =>
                {
                    chckBox.Name = "SelectAllCheckBoxs";
                    //chckBox.Width = 16;
                    //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServiceAcceptance.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
                    //chckBox.Properties.ClientSideEvents.CheckedChanged = "CheckChange";
                    //chckBox.Checked = c.Grid.Selection.Count > 1;
                    chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                    chckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
                }
            ).Render();
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ROW_NUM";
        col.Caption = "No.";
        col.Width = 30;
        col.Visible = true;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    
    setting.Columns.Add(col =>
    {
        col.Width = 20;
        col.FieldName = "ORDER_NO";
        col.Caption = "ORDER_NO";
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

  


    //col.SetDataItemTemplateContent(container =>
    //{
    //    Html.DevExpress().HyperLink(hlSettings =>
    //    {
    //        hlSettings.Name = string.Format("hlpr_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
    //        hlSettings.NavigateUrl = "javascript:void(0)";
    //        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenPrint('{0}', '{1}', '{2}'); }}", (container as GridViewDataItemTemplateContainer).Text, DataBinder.Eval(container.DataItem, "ORDER_NO"), DataBinder.Eval(container.DataItem, "PART_NO"));
    //        hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
    //    }).Render();
    //});
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NO";
        col.Caption = "Part No";
        col.Width = 50;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ openmenu('{0}', '{1}','{2}', '{3}'); }}", DataBinder.Eval(container.DataItem, "KANBAN_NO"), DataBinder.Eval(container.DataItem, "ORDER_NO"), (container as GridViewDataItemTemplateContainer).Text, DataBinder.Eval(container.DataItem, "PART_NAME"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NAME";
        col.Caption = "Part Name";
        
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_NO";
        col.Caption = "Unique No";
        col.Width = 80;
        col.Visible = true;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    
    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Total Kanban";
        //columnBand.Width = Unit.Percentage(50);
        columnBand.Columns.Add(
            column =>
            {

                column.Caption = "Order";
                column.Name = "ORDER";
                column.FieldName = "ORDER";
                column.Width = Unit.Pixel(30);
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
            column =>
            {
                column.Caption = "Received";
                column.Name = "RECEIVE";
                column.FieldName = "RECEIVE";
                column.Width = Unit.Pixel(30);
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
            column =>
            {
                column.Caption = "Shortage";
                column.Name = "SHORTAGE";
                column.FieldName = "SHORTAGE";
                column.Width = Unit.Pixel(30);
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );
    });
    
    setting.Columns.Add(
        column =>
        {
            column.Caption = "Action";
            //column.Name = "DOCK_CD";
            //column.FieldName = "DOCK_CD";
            column.Width = Unit.Pixel(180);
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            column.SetDataItemTemplateContent(c =>
            {
                Html.DevExpress().Button(
                    button =>
                    {
                        button.Name = string.Format("btnReceiveAll[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                        button.Text = "Receive All";
                        button.Width = Unit.Pixel(150);
                        button.Height = Unit.Pixel(10);
                        button.UseSubmitBehavior = true;
                        button.Style.Add("display", "inline-table");
                        button.ControlStyle.CssClass = "btnOkeh";
                        //button.ClientSideEvents.Click = "ReceiveAll("+a.ToString()+")";
                        button.ClientSideEvents.Click = string.Format("function(s,e){{ ReceiveAll({0}); }}", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                    }).Render();
            });
        }
    );

}).Bind(Model.GetModel<KanbanReceivingManifestLevelModel>().KanbanReceivingManifestLevelListData).GetHtml()